function crossRatio()
clear all
close all

set(0,'defaultTextFontName', 'Arial');
set(0,'defaultTextFontSize', 14);
set(0,'defaultTextFontWeight', 'Bold');
set(0,'defaultTextBackgroundColor', [1,1,1]);
set(0,'defaultLineLineWidth', 3);

plot_vanishing = true;

im = imread('piastrella.jpg');

po1 =  [800     1855.5 1];
po2 =  [1451    1132.5 1];
po_23 = [1255.7    1348.8 1];

pv1 =  [1523    1573.5 1];
pv2 =  [191       451.5 1];
pv_12 = [772.5476  942.5329 1];


% vanishing point on the pv points
d_v = pv2 - pv1;
theta_pv2 = norm(d_v);
theta_pv12 = norm(pv_12 - pv1);
d_v = d_v / theta_pv2;
theta__van_v = theta_pv12*theta_pv2/(2*theta_pv12 - theta_pv2);

p_van = pv1 + theta__van_v * d_v; 

% vanishing point on the po point
d_o = po2 - po1;
theta_po2 = norm(d_o);
d_o = d_o / norm(d_o);
theta_po23 = norm(po_23 - po1);

theta_van_o = -theta_po23 * theta_po2 / (2*theta_po2 - 3*theta_po23);

p_van_o = po1 + theta_van_o * d_o;

figure(), imshow(im);
hold on
plot(po1(1), po1(2), 'r+');text(po1(1)-30, po1(2), 'po_1','HorizontalAlignment','right','VerticalAlignment','middle');
plot(po_23(1), po_23(2), 'r+');text(po_23(1)-30, po_23(2), 'po_{2/3}','HorizontalAlignment','right','VerticalAlignment','middle');
plot(po2(1), po2(2), 'r+');text(po2(1)-30, po2(2), 'po_2','HorizontalAlignment','right','VerticalAlignment','middle');

plot(pv1(1), pv1(2), 'b+');text(pv1(1)-30, pv1(2), 'pv_1','HorizontalAlignment','right','VerticalAlignment','middle');
plot(pv2(1), pv2(2), 'b+');text(pv2(1)-30, pv2(2), 'pv_2','HorizontalAlignment','right','VerticalAlignment','middle');
plot(pv_12(1), pv_12(2), 'b+');text(pv_12(1)-30, pv_12(2), 'pv_{12}','HorizontalAlignment','right','VerticalAlignment','middle');

if(plot_vanishing)
    plot(p_van (1), p_van (2), 'm+');text(p_van (1)-30, p_van (2), 'pv_{inf}','HorizontalAlignment','right','VerticalAlignment','middle');
    plot(p_van_o(1), p_van_o(2), 'm+');text(p_van_o(1)-30, p_van_o(2), 'po_{inf}','HorizontalAlignment','right','VerticalAlignment','middle');

    plot([p_van(1) pv1(1)], [p_van(2) pv1(2)], 'g--');
    plot([p_van_o(1) po1(1)], [p_van_o(2) po1(2)], 'g--');

    plot([p_van(1) po1(1)], [p_van(2) po1(2)], 'm--');
    plot([p_van(1) po2(1)], [p_van(2) po2(2)], 'm--');

    plot([p_van_o(1) pv1(1)], [p_van_o(2) pv1(2)], 'm--');
    plot([p_van_o(1) pv2(1)], [p_van_o(2) pv2(2)], 'm--');
end


% plot(point_center(1), point_center(2), 'g+');
% plot(point_vanishing(1), point_vanishing(2), 'g+');
axis auto
hold off
% 
% % to check, plot on the original image and use a point on the field line 
% % graphically check that vanishing is true
% pchk = [684.6745  208.6276 1]';
% 
% % and check that the center is in the middle usign coordinate of the
% % penalty point on the other side
% ppen = [581.6171  151.4630 1]';
% 
% figure(), imshow(imOrig);
% hold on
% 
% plot([bpos(1) point_vanishing(1)], [bpos(2) point_vanishing(2)], 'm--');
% 
% plot(bpos(1), bpos(2), 'r+');text(bpos(1)-20, bpos(2), 'b_+','HorizontalAlignment','right','VerticalAlignment','middle');
% plot(bneg(1), bneg(2), 'r+');text(bneg(1)-20, bneg(2), 'b_-','HorizontalAlignment','right','VerticalAlignment','middle');
% 
% plot(apos(1), apos(2), 'b+');text(apos(1)-20, apos(2), 'a_+','HorizontalAlignment','right','VerticalAlignment','middle');
% plot(aneg(1), aneg(2), 'b+');text(aneg(1)-20, aneg(2), 'a_-','HorizontalAlignment','right','VerticalAlignment','middle');
% 
% plot(point_center(1), point_center(2), 'g+');text(point_center(1)-20, point_center(2), 'C','HorizontalAlignment','right','VerticalAlignment','middle');
% plot(point_vanishing(1), point_vanishing(2), 'g+');text(point_vanishing(1)-20, point_vanishing(2), 'p_v','HorizontalAlignment','right','VerticalAlignment','middle');
% 
% plot([pchk(1) point_vanishing(1)], [pchk(2) point_vanishing(2)], 'm--');
% plot([ppen(1), point_center(1)], [ppen(2), point_center(2)], 'm--');
% axis auto
% hold off
% 
% % figure(), imshow(imOrig);
% end
% 
% function [theta_center, theta_vanishing] =  doubleCross(ta,taa,tb,tbb)
% % taa, tbb : negative
% % ta, tb : positive
% theta_center = [
%  (2*ta*taa - 2*tb*tbb)/(ta + taa - tb - tbb) + (tb*tbb - ta*taa + (ta^2*taa^2 - ta^2*taa*tb - ta^2*taa*tbb + ta^2*tb*tbb - ta*taa^2*tb - ta*taa^2*tbb + ta*taa*tb^2 + 2*ta*taa*tb*tbb + ta*taa*tbb^2 - ta*tb^2*tbb - ta*tb*tbb^2 + taa^2*tb*tbb - taa*tb^2*tbb - taa*tb*tbb^2 + tb^2*tbb^2)^(1/2))/(ta + taa - tb - tbb)
%  (2*ta*taa - 2*tb*tbb)/(ta + taa - tb - tbb) - (ta*taa - tb*tbb + (ta^2*taa^2 - ta^2*taa*tb - ta^2*taa*tbb + ta^2*tb*tbb - ta*taa^2*tb - ta*taa^2*tbb + ta*taa*tb^2 + 2*ta*taa*tb*tbb + ta*taa*tbb^2 - ta*tb^2*tbb - ta*tb*tbb^2 + taa^2*tb*tbb - taa*tb^2*tbb - taa*tb*tbb^2 + tb^2*tbb^2)^(1/2))/(ta + taa - tb - tbb)
% ];
% 
% % center has to greater than > taa and > tbb, < tb, <ta
% sel_th1 = theta_center(1) > taa && theta_center(1) > tbb && theta_center(1) < ta  && theta_center(1) < tb
% sel_th2 = theta_center(2) > taa && theta_center(2) > tbb && theta_center(2) < ta  && theta_center(2) < tb
% 
% assert(xor(sel_th1,sel_th2))
% 
% if(sel_th1)
%     theta_center = theta_center(1);
% else
%     theta_center = theta_center(2);
% end
% 
% theta_vanishing =[
%  -(tb*tbb - ta*taa + (ta^2*taa^2 - ta^2*taa*tb - ta^2*taa*tbb + ta^2*tb*tbb - ta*taa^2*tb - ta*taa^2*tbb + ta*taa*tb^2 + 2*ta*taa*tb*tbb + ta*taa*tbb^2 - ta*tb^2*tbb - ta*tb*tbb^2 + taa^2*tb*tbb - taa*tb^2*tbb - taa*tb*tbb^2 + tb^2*tbb^2)^(1/2))/(ta + taa - tb - tbb)
%   (ta*taa - tb*tbb + (ta^2*taa^2 - ta^2*taa*tb - ta^2*taa*tbb + ta^2*tb*tbb - ta*taa^2*tb - ta*taa^2*tbb + ta*taa*tb^2 + 2*ta*taa*tb*tbb + ta*taa*tbb^2 - ta*tb^2*tbb - ta*tb*tbb^2 + taa^2*tb*tbb - taa*tb^2*tbb - taa*tb*tbb^2 + tb^2*tbb^2)^(1/2))/(ta + taa - tb - tbb)
% ];
% 
% % vanishing has to be (> ta and > tb) or (< taa and < tbb) 
% 
% sel_tv1 = (theta_vanishing(1) > ta && theta_vanishing(1) > tb) || (theta_vanishing(1) < taa && theta_vanishing(1) < tbb);
% sel_tv2 = (theta_vanishing(2) > ta && theta_vanishing(2) > tb) || (theta_vanishing(2) < taa && theta_vanishing(2) < tbb);
% 
% assert(xor(sel_tv1,sel_tv2))
% 
% if(sel_tv1)
%     theta_vanishing = theta_vanishing(1);
% else
%     theta_vanishing = theta_vanishing(2);
% end


end