clear all
close all

i1 = imread('drexel.png');

%              x         y       w
pSource = [ 179  525  1
            187   73  1
%            687  307  1
            690  307  1
            698  467  1]';
figure(),imshow(i1)
hold on
plot([pSource(1,:) pSource(1,1)],[pSource(2,:) pSource(2,1)],'r');
hold off
        
pDest = [   0     180
            0     0
            822   0
            822   180]'; % cartesian

% for each point create the rows of the system matrix
b = nan(size(pSource,2),1);
A = nan(size(pSource,2),8);

for i = 1 : size(pSource,2)
    x = pSource(1,i);
    y = pSource(2,i);
    w = pSource(3,i);
    
    xp = pDest(1,i);
    yp = pDest(2,i);

    A((i - 1) * 2 + 1,:) = [x, y ,w, 0, 0, 0, -xp*x, -xp*y];
    A((i - 1) * 2 + 2,:) = [0, 0, 0, x, y ,w, -yp*x, -yp*y];
    
    b((i - 1) * 2 + 1,:) = xp*w;
    b((i - 1) * 2 + 2,:) = yp*w;
end

h = A\b;

H = reshape([h;1],3,3)';

[i2, newT] = imTrans(i1,H);

% note: newT is a second transformation to scale and center the resulting
% image

pDest2 = inv(newT) * H * pSource;
pDest2(1,:) = pDest2(1,:) ./ pDest2(3,:);
pDest2(2,:) = pDest2(2,:) ./ pDest2(3,:);
pDest2(3,:) = ones(1,size(pDest2,2));
figure(),imshow(i2);
hold on
plot([pDest2(1,:) pDest2(1,1)],[pDest2(2,:) pDest2(2,1)],'r');
hold off
